%global _version 2.0.18
%global _release 14
%global is_systemd 1
%global enable_shimv2 1
%global is_embedded 1

Name:      iSulad
Version:   %{_version}
Release:   %{_release}
Summary:   Lightweight Container Runtime Daemon
License:   Mulan PSL v2
URL:       https://gitee.com/openeuler/iSulad
Source:    https://gitee.com/openeuler/iSulad/repository/archive/v%{version}.tar.gz
BuildRoot: {_tmppath}/iSulad-%{version}

Patch0001:	0001-add-omitted-musl-adaption-code.patch
Patch0002:	0002-add-cpu-rt-CI.patch
Patch0003:	0003-add-cpu-rt-ut.patch
Patch0004:	0004-add-info-log-when-isulad-shutdown.patch
Patch0005:	0005-create-a-log-file-for-shim-v2-and-remove-10-229-devi.patch
Patch0006:	0006-ensure-isula-exec-inherits-the-config-of-create.patch
Patch0007:	0007-Delete-meaningless-thread-creation-and-ensure-the-ta.patch
Patch0008:	0008-fix-cpu-rt-review-comments.patch
Patch0009:	0009-fix-inspect.sh-failed.patch
Patch0010:	0010-ensure-list-name-is-not-null.patch
Patch0011:	0011-Bugfix-in-config-and-executor.patch
Patch0012:	0012-fix-isula-cpu-rt-CI.patch
Patch0013:	0013-add-CRI-ContainerStats-Service.patch
Patch0014:	0014-fix-selinux_label_ut-timeout-and-add-timeout-for-all.patch
Patch0015:	0015-fix-cpu-rt-disable-after-reboot-machine.patch
Patch0016:	0016-fix-code-style.patch
Patch0017:	0017-add-retry-for-read-write.patch
Patch0018:	0018-add-crictl-timeout-and-sync-for-CI.patch
Patch0019:	0019-unlock-m_podsLock-if-new-failed.patch
Patch0020:	0020-fix-CRI-SetupPod-and-TearDownPod-deadlock.patch
Patch0021:	0021-support-pull-image-with-digest.patch
Patch0022:	0022-isulad-shim-support-execSync-with-timeout.patch
Patch0023:	0023-change-sleep-to-usleep-to-avoid-lossing-of-accuracy.patch
Patch0024:	0024-adapt-to-repo-of-openeuler-url-changed.patch
Patch0025:	0025-modify-sleep-time.patch
Patch0026:	0026-change-goto-branch.patch
Patch0027:	0027-modifying-cpurt-file-permissions.patch
Patch0028:	0028-add-design-docs-for-cri-manager.patch
Patch0029:	0029-improve-check-of-process-failure.patch
Patch0030:	0030-support-isula-update-when-runtime-is-runc.patch
Patch0031:	0031-when-calling-runc-start-unset-NOTIFY_-SOCKET.patch
Patch0032:	0032-add-CRI-container-design-doc.patch
Patch0033:	0033-fix-util_getgrent_r-overflow.patch
Patch0034:	0034-modify-the-return-value-of-the-util_waitpid_with_tim.patch
Patch0035:	0035-fix-inspect-data-memleak.patch
Patch0036:	0036-containers-in-same-sandbox-should-have-same-process-.patch
Patch0037:	0037-clean-container-process-after-execSync-timeout-exit.patch
Patch0038:	0038-support-to-config-selinux-label-in-cri.patch
Patch0039:	0039-add-files_limit-to-oci-spec.patch
Patch0040:	0040-support-setting-pod-to-privilege.patch
Patch0041:	0041-add-hugepage_limit.patch
Patch0042:	0042-add-effective-and-permitted-type-of-cap-to-oci-spec.patch
Patch0043:	0043-isulad-shim-fix-log-loss-bug.patch
Patch0044:	0044-remove-unused-func.patch
Patch0045:	0045-if-the-exit-code-in-the-response-of-execSync-is-not-.patch
Patch0046:	0046-free-timeout-when-shim_create-finished.patch
Patch0047:	0047-clean-isulad-shim-compile-relies.patch
Patch0048:	0048-remote-layer-store-demo.patch
Patch0049:	0049-add-ci-for-remote-ro.patch
Patch0050:	0050-fix-compile-error-when-not-enable-remote-ro.patch
Patch0051:	0051-CI-not-enable-remote-ro-for-ut.patch
Patch0052:	0052-bugfix-remote-ro-try-add-or-remove-image-layer-twice.patch
Patch0053:	0053-bugfix-can-t-delete-layers-under-dir-overlay-layers.patch
Patch0054:	0054-refactor-remote-ro-code.patch
Patch0055:	0055-bugfix-when-refresh-can-t-load-or-pull-images.patch
Patch0056:	0056-remove-unused-headers.patch
Patch0057:	0057-change-isulad-shim-epoll-struct.patch
Patch0058:	0058-fix-memrealloc-size-error.patch
Patch0059:	0059-convert-struct-lcr-start-exec-request.patch
Patch0060:	0060-fix-security-warning.patch
Patch0061:	0061-add-testcase-for-hook-env.patch
Patch0062:	0062-fix-security-warning.patch
Patch0063:	0063-add-try_generate_exec_id-func-for-health-check.patch
Patch0064:	0064-split-remote-grpc-code-by-macro.patch
Patch0065:	0065-move-signal_routine-and-g_log_fd-to-common-and-and-s.patch
Patch0066:	0066-add-ut-for-runc.patch
Patch0067:	0067-runc-add-ci-for-runc.patch
Patch0068:	0068-fix-ci-error.patch
Patch0069:	0069-restore-bind_special_dir.sh.patch
Patch0070:	0070-ensure-isulad_io-not-NULL-before-close-fd.patch
Patch0071:	0071-recheck-delete-command-exit-status.patch
Patch0072:	0072-restore-execSync-return-value.patch
Patch0073:	0073-fix-memory-leak-and-array-access-out-of-range.patch
Patch0074:	0074-fix-memory-leak-of-top_layer.patch
Patch0075:	0075-ensure-define-in-local-and-use-correctly-type.patch
Patch0076:	0076-fix-don-t-cleanup-when-remote-ro-is-enabled.patch
Patch0077:	0077-fix-layer-imcomplete-cause-isulad-core.patch
Patch0078:	0078-add-load-layer-testcase.patch
Patch0079:	0079-2037-archive-reader-close-if-copy-to-container-faile.patch
Patch0080:	0080-RO-refactor-remote-ro-code.patch
Patch0081:	0081-fix-lose-ipc-shm-mount-point.patch
Patch0082:	0082-CI-add-testcase-for-ipc-ns.patch
Patch0083:	0083-fix-inspect-image-by-digest.patch
Patch0084:	0084-add-isulad-basic-image-test-with-digest.patch
Patch0085:	0085-return-non-zero-if-copy-invalid.patch
Patch0086:	0086-add-invalid-copy-testcase.patch
Patch0087:	0087-2048-fix-some-code-check-error.patch
Patch0088:	0088-2046-reinforce-cri_stream.sh-and-health_check.sh.patch
Patch0089:	0089-2047-distinguishing-exit-codes-between-shim-and-cont.patch
Patch0090:	0090-2052-fix-some-codecheck.patch
Patch0091:	0091-disable-the-exec-timeout-function-for-kata-runtime.patch
Patch0092:	0092-debug-improve-debug-message-for-gc-containers.patch
Patch0093:	0093-refactor-rt_isula_exec-and-shim-log.patch
Patch0094:	0094-add-some-exec-test.patch
Patch0095:	0095-2079-clean-network-reosurces-if-runpodsandbox-failed.patch
Patch0096:	0096-fix-stuck-health-check-blocking-container-stop-bugs.patch
Patch0097:	0097-add-health-check-abnormal-test_cases.patch
Patch0098:	0098-restore-health-check-fix.patch
Patch0099:	0099-remove-health-check-abnormal-test_cases.patch
Patch0100:	0100-bugfix-for-implicit_digest.patch
Patch0101:	0101-add-testcases-for-inspect-images-by-digest-after-res.patch
Patch0102:	0102-fix-loading-of-nsswitch-based-config-inside-chr.patch
Patch0103:	0103-Added-restrictions-on-container-health-checks.patch
Patch0104:	0104-add-testcases-for-restrictions-on-container-health-c.patch
Patch0105:	0105-link-libcap-for-storage_layers_ut-and-storage_d.patch
Patch0106:	0106-modify-the-help-information-of-health-timeout.patch
Patch0107:	0107-improve-coding.patch
Patch0108:	0108-2116-clean-up-sensitive-information-in-memory.patch
Patch0109:	0109-2118-Fix-exec-buffer-overflow.patch
Patch0110:	0110-2117-limit-the-length-of-runtime-args-and-increase-t.patch
Patch0111:	0111-ensure-argument-of-interface-is-not-null.patch
Patch0112:	0112-2123-add-verify-for-snprintf-and-fix-some-codecheck-.patch
Patch0113:	0113-clear-author-msg-in-isulad-check.sh-and-use-EANBLE_I.patch
Patch0114:	0114-2126-do-not-judge-the-snprintf-result-of-hostname.patch
Patch0115:	0115-image-ensure-id-of-loaded-and-pulled-image-is-valid.patch
Patch0116:	0116-2129-Limit-the-response-size-of-ExecSync.patch
Patch0117:	0117-improve-use-return-error-to-replace-abort.patch
Patch0118:	0118-2137-do-clean-code.patch
Patch0119:	0119-2135-modify-incorrect-variable-type.patch
Patch0120:	0120-Fix-null-ptr-and-buffer-overflow-issues.patch
Patch0121:	0121-make-sure-the-input-parameter-is-not-empty-and-optim.patch
Patch0122:	0122-2149-archive-fork-process-set-pdeathsig.patch
Patch0123:	0123-improve-by-code-check-of-cpp.patch
Patch0124:	0124-remove-password-in-url-module-and-clean-sensitive-in.patch
Patch0125:	0125-2153-fix-codecheck.patch
Patch0126:	0126-2154-fix-code-bug.patch
Patch0127:	0127-2157-bugfix-for-memset.patch
Patch0128:	0128-2159-use-macros-to-isolate-the-password-option-of-lo.patch
Patch0129:	0129-2160-Fix-nullptr-in-src-daemon-entry.patch
Patch0130:	0130-2161-bugfix-for-api-cmakelist.patch
Patch0131:	0131-2164-add-bind-mount-file-lock.patch
Patch0132:	0132-2165-preventing-the-use-of-insecure-isulad-tmpdir-di.patch
Patch0133:	0133-2166-move-ensure_isulad_tmpdir_security-function-to-.patch
Patch0134:	0134-2169-using-macros-to-isolate-isulad-s-enable_plugin-.patch
Patch0135:	0135-mask-proxy-informations.patch
Patch0136:	0136-add-testcase-for-isula-info.patch
Patch0137:	0137-2172-remove-unneccessary-strerror.patch
Patch0138:	0138-replace-COMMAND_ERROR-to-CMD_SYSERROR.patch
Patch0139:	0139-do-not-report-low-level-error-to-user.patch
Patch0140:	0140-remove-usage-of-strerror-with-user-defined-errno.patch
Patch0141:	0141-use-gmtime_r-to-replace-gmtime.patch
Patch0142:	0142-improve-report-error-message-of-client.patch
Patch0143:	0143-adapt-new-error-message-for-isula-cp.patch
Patch0144:	0144-2178-clean-path-for-fpath-and-verify-chain-id.patch
Patch0145:	0145-2179-modify-the-permissions-of-tmpdir-and-file-lock-.patch
Patch0146:	0146-2195-Add-retry-function-for-bigdata_stream_runc.patch
Patch0147:	0147-2213-bugfix-for-rt_isula_exec_resize.patch
Patch0148:	0148-2214-imporove-isula_rt_opts-code.patch
Patch0149:	0149-refactor-update-possible-changed-resources-for-oci-s.patch
Patch0150:	0150-add-CI-testcase-for-update-oci-spec-in-start-op.patch
Patch0151:	0151-2239-delete-the-disabled-reload-configuration-in-isu.patch
Patch0152:	0152-2240-modify-the-default-value-of-EANBLE_IMAGE_LIBARA.patch
Patch0153:	0153-improve-event-logs.patch
Patch0154:	0154-2257-disable-grpc-remote-connect-by-default.patch
Patch0155:	0155-2258-rollback-commit-for-update-possible-changed-res.patch
Patch0156:	0156-2259-lcr-container-with-a-damaged-config-file-will-r.patch
Patch0157:	0157-2263-use-dev-random-to-replace-dev-urandom.patch
Patch0158:	0158-2264-bugfix-for-runc-container-exec.patch
Patch0159:	0159-2262-bugfix-of-update-restart-policy-for-auto-remove.patch
Patch0160:	0160-2265-use-dev-urandom-to-replace-dev-random.patch
Patch0161:	0161-open-ENABLE_GRPC_REMOTE_CONNECT-in-CI-and-bugfix-for.patch
Patch0162:	0162-2274-bugfix-for-rt_lcr_rebuild_config.patch
Patch0163:	0163-use-RAND_bytes-to-replace-dev-urandom.patch
Patch0164:	0164-fix-the-problem-of-abnormal-branches-not-waiting-for.patch
Patch0165:	0165-2286-bugfix-for-the-bliko-zero-value-exception-when-.patch
Patch0166:	0166-move-variable-declaration-out-of-loop.patch
Patch0167:	0167-fix-error-for-cat-bigdata-in-oci-runtime.patch
Patch0168:	0168-use-a-timeout-epoll-loop-to-ensure-complete-data-rec.patch
Patch0169:	0169-2293-reduce-epoll-loop-timeout-time.patch
Patch0170:	0170-2294-keep-the-service-status-unchanged-after-iSulad-.patch
Patch0171:	0171-2299-remove-close-fd-from-stdout_cb-and-stderr_cb.patch
Patch0172:	0172-add-ut-for-devicemapper.patch
Patch0173:	0173-remove-build-and-test-in-coverage.patch
Patch0174:	0174-modify-the-default-value-of-ISULAD_TMPDIR-to-var-lib.patch
Patch0175:	0175-prevent-the-parent-dir-from-being-bind-mounted-to-th.patch
Patch0176:	0176-verify-the-mount-dir-first-and-then-create-tmpdir.patch
Patch0177:	0177-bugfix-del-redundant-code.patch
Patch0178:	0178-remove-var-in-coverage-and-fix-build-test-remove.patch
Patch0179:	0179-code-improve-for-oci_rmi.patch
Patch0180:	0180-verify-name-and-digest-consistency.patch
Patch0181:	0181-bugfix-for-resort_image_names.patch

%ifarch x86_64 aarch64
Provides:       libhttpclient.so()(64bit)
Provides:       libisula.so()(64bit)
Provides:       libisulad_tools.so()(64bit)
%endif

%if 0%{?is_systemd}
# Systemd 230 and up no longer have libsystemd-journal
BuildRequires: pkgconfig(systemd)
Requires: systemd-units
%else
Requires(post): chkconfig
Requires(preun): chkconfig
# This is for /sbin/service
Requires(preun): initscripts
%endif

%if 0%{?is_embedded}
BuildRequires: sqlite-devel
Requires: sqlite
%endif

%if %{defined openeuler}
BuildRequires: gtest-devel gmock-devel
%endif

%define lcrver_lower 2.0.9-0
%define lcrver_upper 2.0.10-0
%define clibcniver_lower 2.0.7-0
%define clibcniver_upper 2.0.8-0

BuildRequires: lcr-devel > %{lcrver_lower} lcr-devel < %{lcrver_upper}
BuildRequires: clibcni-devel > %{clibcniver_lower} clibcni-devel < %{clibcniver_upper}
BuildRequires: cmake gcc-c++ yajl-devel lxc lxc-devel
BuildRequires: grpc grpc-plugins grpc-devel protobuf-devel
BuildRequires: libcurl libcurl-devel libarchive-devel device-mapper-devel
BuildRequires: http-parser-devel
BuildRequires: libseccomp-devel libcap-devel libselinux-devel libwebsockets libwebsockets-devel
BuildRequires: systemd-devel git
%if 0%{?enable_shimv2}
BuildRequires: lib-shim-v2 lib-shim-v2-devel
%endif


Requires:      lcr > %{lcrver_lower} lcr < %{lcrver_upper}
Requires:      clibcni > %{clibcniver_lower} clibcni < %{clibcniver_upper}
Requires:      grpc protobuf lxc
Requires:      libcurl
Requires:      http-parser libseccomp
Requires:      libcap libselinux libwebsockets libarchive device-mapper
Requires:      systemd
%if 0%{?enable_shimv2}
Requires:      lib-shim-v2
%endif

%description
This is a umbrella project for gRPC-services based Lightweight Container
Runtime Daemon, written by C.

%prep
%autosetup -n iSulad-v%{_version} -Sgit -p1

%build
mkdir -p build
cd build
%if 0%{?enable_shimv2}
%if %{defined openeuler}
%cmake -DDEBUG=ON -DCMAKE_SKIP_RPATH=TRUE -DLIB_INSTALL_DIR=%{_libdir} -DCMAKE_INSTALL_PREFIX=/usr -DENABLE_SHIM_V2=ON -DENABLE_UT=ON ../
%else
%cmake -DDEBUG=ON -DCMAKE_SKIP_RPATH=TRUE -DLIB_INSTALL_DIR=%{_libdir} -DCMAKE_INSTALL_PREFIX=/usr -DENABLE_SHIM_V2=ON ../
%endif
%else
%if %{defined openeuler}
%cmake -DDEBUG=ON -DCMAKE_SKIP_RPATH=TRUE -DLIB_INSTALL_DIR=%{_libdir} -DCMAKE_INSTALL_PREFIX=/usr -DENABLE_UT=ON ../
%else
%cmake -DDEBUG=ON -DCMAKE_SKIP_RPATH=TRUE -DLIB_INSTALL_DIR=%{_libdir} -DCMAKE_INSTALL_PREFIX=/usr ../
%endif
%endif
%make_build

%check
%if %{defined openeuler}
cd build
# registry_images_ut ,volume_ut and driver_devmapper_ut must run with root user
ctest -E "registry_images_ut|volume_ut|driver_devmapper_ut"
%endif

%install
rm -rf %{buildroot}
cd build
install -d $RPM_BUILD_ROOT/%{_libdir}
install -m 0755 ./src/libisula.so             %{buildroot}/%{_libdir}/libisula.so
install -m 0755 ./src/utils/http/libhttpclient.so  %{buildroot}/%{_libdir}/libhttpclient.so
install -m 0755 ./src/libisulad_tools.so  %{buildroot}/%{_libdir}/libisulad_tools.so

install -d $RPM_BUILD_ROOT/%{_libdir}/pkgconfig
install -m 0640 ./conf/isulad.pc              %{buildroot}/%{_libdir}/pkgconfig/isulad.pc

install -d $RPM_BUILD_ROOT/%{_bindir}

install -m 0755 ./src/isula                  %{buildroot}/%{_bindir}/isula
install -m 0755 ./src/isulad-shim            %{buildroot}/%{_bindir}/isulad-shim

install -m 0755 ./src/isulad                 %{buildroot}/%{_bindir}/isulad

install -d $RPM_BUILD_ROOT/%{_includedir}/isulad

install -d $RPM_BUILD_ROOT/%{_sysconfdir}/isulad
install -m 0640 ../src/contrib/config/daemon.json           %{buildroot}/%{_sysconfdir}/isulad/daemon.json
install -m 0440 ../src/contrib/config/daemon_constants.json %{buildroot}/%{_sysconfdir}/isulad/daemon_constants.json
install -m 0640 ../src/contrib/config/seccomp_default.json  %{buildroot}/%{_sysconfdir}/isulad/seccomp_default.json

install -d $RPM_BUILD_ROOT/%{_sysconfdir}/default/isulad
install -m 0640 ../src/contrib/config/config.json           %{buildroot}/%{_sysconfdir}/default/isulad/config.json
install -m 0640 ../src/contrib/config/systemcontainer_config.json           %{buildroot}/%{_sysconfdir}/default/isulad/systemcontainer_config.json
install -m 0550 ../src/contrib/sysmonitor/isulad-check.sh        %{buildroot}/%{_sysconfdir}/default/isulad/isulad-check.sh

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/sysmonitor/process
cp ../src/contrib/sysmonitor/isulad-monit $RPM_BUILD_ROOT/etc/sysmonitor/process

install -d $RPM_BUILD_ROOT/%{_sysconfdir}/default/isulad/hooks
install -m 0640 ../src/contrib/config/hooks/default.json %{buildroot}/%{_sysconfdir}/default/isulad/hooks/default.json

install -d $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig
install -p -m 0640 ../src/contrib/config/iSulad.sysconfig $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/iSulad

%if 0%{?is_systemd}
install -d $RPM_BUILD_ROOT/%{_unitdir}
install -p -m 0640 ../src/contrib/init/isulad.service $RPM_BUILD_ROOT/%{_unitdir}/isulad.service
%else
install -d $RPM_BUILD_ROOT/%{_initddir}
install -p -m 0640 ../src/contrib/init/isulad.init $RPM_BUILD_ROOT/%{_initddir}/isulad.init
%endif

%clean
rm -rf %{buildroot}

%pre
# support update from lcrd to isulad, will remove in next version
if [ "$1" = "2" ]; then
%if 0%{?is_systemd}
systemctl stop lcrd &>/dev/null
systemctl disable lcrd &>/dev/null
if [ -e %{_sysconfdir}/isulad/daemon.json ];then
    sed -i 's#/etc/default/lcrd/hooks#/etc/default/isulad/hooks#g' %{_sysconfdir}/isulad/daemon.json
fi
%else
/sbin/chkconfig --del lcrd &>/dev/null
%endif
fi

%post
if ! getent group isula > /dev/null; then
    groupadd --system isula
fi

if [ "$1" = "1" ]; then
%if 0%{?is_systemd}
systemctl enable isulad
systemctl start isulad
%else
/sbin/chkconfig --add isulad
%endif
elif [ "$1" = "2" ]; then
%if 0%{?is_systemd}
# support update from lcrd to isulad, will remove in next version
if [ -e %{_unitdir}/lcrd.service.rpmsave ]; then
    mv %{_unitdir}/lcrd.service.rpmsave %{_unitdir}/isulad.service
    sed -i 's/lcrd/isulad/g' %{_unitdir}/isulad.service
fi
systemctl status isulad | grep 'Active:' | grep 'running'
if [ $? -eq 0 ]; then
  systemctl restart isulad
else
  systemctl start isulad
fi
%else
/sbin/service isulad status | grep 'Active:' | grep 'running'
if [ $? -eq 0 ]; then
  /sbin/service isulad restart
fi
%endif
fi

if ! getent group isula > /dev/null; then
    groupadd --system isula
fi

%preun
%if 0%{?is_systemd}
%systemd_preun isulad
%else
if [ $1 -eq 0 ] ; then
    /sbin/service isulad stop >/dev/null 2>&1
    /sbin/chkconfig --del isulad
fi
%endif

%postun
%if 0%{?is_systemd}
%systemd_postun_with_restart isulad
%else
if [ "$1" -ge "1" ] ; then
    /sbin/service isulad condrestart >/dev/null 2>&1 || :
fi
%endif

%files
%attr(0600,root,root) %{_sysconfdir}/sysmonitor/process/isulad-monit
%attr(0550,root,root) %{_sysconfdir}/default/isulad/isulad-check.sh
%defattr(0640,root,root,0750)
%{_sysconfdir}/isulad
%{_sysconfdir}/isulad/*
%{_sysconfdir}/default/*
%defattr(-,root,root,-)
%if 0%{?is_systemd}
%{_unitdir}/isulad.service
%attr(0640,root,root) %{_unitdir}/isulad.service
%else
%{_initddir}/isulad.init
%attr(0640,root,root) %{_initddir}/isulad.init
%endif
%attr(0755,root,root) %{_libdir}/pkgconfig
%attr(0640,root,root) %{_libdir}/pkgconfig/isulad.pc
%defattr(0755,root,root,0755)
%{_bindir}/*
%{_libdir}/*
%attr(0640,root,root) %{_sysconfdir}/sysconfig/iSulad
%attr(0640,root,root) %{_sysconfdir}/isulad/daemon.json

%config(noreplace,missingok) %{_sysconfdir}/sysconfig/iSulad
%config(noreplace,missingok) %{_sysconfdir}/isulad/daemon.json
%if 0%{?is_systemd}
%config(noreplace,missingok) %{_unitdir}/isulad.service
%else
%config(noreplace,missingok) %{_initddir}/isulad.init
%endif

%changelog
* Thu Dec 21 2023 zhongtao <zhongtao17@huawei.com> - 2.0.18-13
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: upgrade from upstream

* Mon Sep 18 2023 zhongtao <zhongtao17@huawei.com> - 2.0.18-13
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: upgrade from upstream

* Thu Aug 24 2023 zhongtao <zhongtao17@huawei.com> - 2.0.18-12
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: code improvements and bugfix for code review

* Tue Aug 15 2023 zhongtao <zhongtao17@huawei.com> - 2.0.18-11
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: upgrade from upstream

* Wed Jul 19 2023 zhongtao <zhongtao17@huawei.com> - 2.0.18-10
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: upgrade from upstream

* Thu Jun 01 2023 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.18-9
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: upgrade from upstream

* Mon May 08 2023 penghaitao <htpengc@isoftstone.com> - 2.0.18-8
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fix bogus date in %changelog

* Fri May 05 2023 wangrunze<wangrunze13@huawei.com> - 2.0.18-7
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fix memrealloc size error and convert struct

* Thu May 04 2023 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.18-6
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: upgrade from upstream

* Mon Apr 24 2023 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.18-5
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: bugfix for runc and cri

* Thu Mar 09 2023 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.18-4
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: upgrade from upstream

* Wed Feb 22 2023 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.18-3
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: upgrade from upstream

* Thu Feb 16 2023 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.18-2
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: add check

* Tue Jan 03 2023 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.18-1
- Type: update
- ID: NA
- SUG: NA
- DESC: update to v2.0.18

* Thu Dec 22 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-14
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: remove clean_module_fill_ctx for libisulad_img.so

* Mon Dec 19 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-13
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: update lcr dependence version

* Fri Dec 16 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-12
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: update from upstream

* Tue Dec 06 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-11
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: update from upstream

* Mon Nov 28 2022 yangjiaqi <yangjiaqi16@huawei.com> - 2.0.17-10
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: remove chmod 751 permission for dirs by engine when user-remap enabled

* Fri Nov 25 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-9
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: add primary group to additional groups

* Mon Nov 21 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-8
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fix cannot install isulad and unknown option

* Wed Nov 16 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-7
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: update tar package from source

* Wed Nov 02 2022 wangrunze <wangrunze13@huawei.com> - 2.0.17-6
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fix cleanup module memory leak

* Tue Nov 01 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-5
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: add ut and bugfix for device mapper and websocket

* Mon Oct 31 2022 wujing <wujing50@huawei.com> - 2.0.17-4
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sync from openEuler

* Wed Oct 19 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-3
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: add required package lcr clibcni lower and upper version

* Mon Oct 10 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-2
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: use epoll instead of select for wait_exit_fifo

* Sun Oct 09 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.17-1
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: update iSulad version to 2.0.17-1

* Thu Sep 29 2022 haozi007 <liuhao27@huawei.com> - 2.0.16-8
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sync from openEuler

* Tue Sep 20 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.16-7
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: change libisulad_tools.so mode

* Thu Sep 15 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.16-6
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: shield upgrade error if lcrd not exist

* Tue Sep 13 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.16-5
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: calculate timezone by tm_gmtoff

* Thu Sep 08 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.16-4
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: invalid free default-runtime and cri-runtime after free json-confs

* Wed Sep 07 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.16-3
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sycn patches from openeuler/iSulad

* Tue Aug 30 2022 leizhongkai <leizhongkai@huawei.com> - 2.0.16-2
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sync from upstream openeuler/iSulad

* Tue Aug 23 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.16-1
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: update iSulad version to 2.0.16-1

* Mon Aug 22 2022 zhongtao <zhongtao17@huawei.com> - 2.0.15-6
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: remove rpath by cmake

* Wed Aug 17 2022 haozi007 <liuhao27@huawei.com> - 2.0.15-5
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sycn patches from openeuler

* Mon Aug 15 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.15-4
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: change default umask to 0022

* Tue Aug 9 2022 haozi007 <liuhao27@huawei.com> - 2.0.15-3
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sycn patches from openeuler

* Mon Aug 1 2022 chengzeruizhi <chengzeruizhi@huawei.com> - 2.0.15-2
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sycn patches from openeuler branch

* Fri Jul 8 2022 haozi007 <liuhao27@huawei.com> - 2.0.15-1
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: update version to v2.0.15

* Fri Jul 8 2022 haozi007 <liuhao27@huawei.com> - 2.0.14-11
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: add limit to lcr version

* Wed Jun 22 2022 yangjiaqi <yangjiaqi16@huawei.com> - 2.0.14-10
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sync from upstream openeuler/iSulad

* Tue Jun 21 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.14-9
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sync from upstream openeuler/iSulad

* Wed Jun 15 2022 chengzeruizhi <chengzeruizhi@huawei.com> - 2.0.14-8
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sync from upstream openeuler/iSulad

* Tue May 31 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.14-7
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: fix type convert, add null pointer check, remove unuse macro

* Tue May 31 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.14-6
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: fix different type convert and add check to arguments

* Mon May 30 2022 chengzrz <chengzeruizhi@huawei.com> - 2.0.14-5
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: seccomp optimization

* Fri May 27 2022 haozi007 <liuhao27@huawei.com> - 2.0.14-4
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: improve fuzz test for pw and gr parser

* Tue May 24 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.14-3
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: fix install error when android

* Tue May 24 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.14-2
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: do not mkdir of isulad if no controller found

* Mon May 23 2022 haozi007 <liuhao27@huawei.com> - 2.0.14-1
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: update version to v2.0.14

* Mon May 16 2022 haozi007<liuhao27@huawei.com> - 2.0.13-5
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sync from upstream openEuler/iSulad

* Tue May 10 2022 hejunjie<hejunjie10@huawei.com> - 2.0.13-4
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: bionic adaptation, increase lcov coverage

* Thu May 5 2022 hejunjie<hejunjie10@huawei.com> - 2.0.13-3
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: bionic adaptation for pwgr obj parser

* Mon Apr 25 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.13-2
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: sync from upstream

* Mon Apr 18 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.13-1
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: update version to v2.0.13

* Fri Mar 25 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.12-1
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: update version to v2.0.12

* Thu Mar 17 2022 haozi007 <liuhao27@huawei.com> - 2.0.11-6
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: remove unnecessary error message

* Thu Mar 17 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.11-5
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fix uid/gid error when load image

* Wed Mar 09 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.11-4
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: add provides of libisulad_tools.so

* Thu Mar 03 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.11-3
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: Add the function of isolating the user namespaces

* Thu Mar 03 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.11-2
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: add libisulad_tools.so

* Thu Feb 24 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.11-1
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: update version to v2.0.11

* Wed Jan 12 2022 wangfengtu <wangfengtu@huawei.com> - 2.0.10-15
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fix compile error of isula-transform

* Mon Jan 10 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.10-14
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fix compile error with grpc 1.41.x

* Mon Jan 10 2022 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.10-13
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fix compile error when building embedded image

* Mon Dec 27 2021 wangfengtu <wangfengtu@huawei.com> - 2.0.10-12
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: sync patches from upstream

* Thu Dec 09 2021 chengzeruizhi <chengzeruizhi@huawei.com> - 2.0.10-11
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fixed a bug that occurs when starting a container in host mode

* Thu Dec 09 2021 wangfengtu <wagnfengtu@huawei.com> - 2.0.10-10
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: remove dependance of sqlite

* Mon Dec 06 2021 gaohuatao <gaohuatao@huawei.com> - 2.0.10-9
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: specify version

* Fri Dec 03 2021 wangfengtu <wangfengtu@huawei.com> - 2.0.10-8
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fix undefined reference to `service_arguments_free' in libisulad_img.so

* Thu Dec 02 2021 wangfengtu <wangfengtu@huawei.com> - 2.0.10-7
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: sync patches from upstream

* Tue Nov 23 2021 chengzeruizhi <chengzeruizhi@huawei.com> - 2.0.10-6
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: modify the procedure of running a pod

* Fri Nov 19 2021 gaohuatao <gaohuatao@huawei.com> - 2.0.10-5
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: sync from upstream

* Fri Nov 19 2021 wangfengtu <wangfengtu@huawei.com> - 2.0.10-4
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: fix memleak when use multiple --volumes-from

* Tue Nov 16 2021 wujing <wujing50@huawei.com> - 2.0.10-3
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: add shimv2 build switch

* Tue Nov 16 2021 wujing <wujing50@huawei.com> - 2.0.10-2
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: remove build platform restrictions

* Tue Nov 09 2021 gaohuatao <gaohuatao@huawei.com> - 2.0.10-1
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: update from openeuler

* Tue Oct 19 2021 wangfengtu <wangfengtu@huawei.com> - 2.0.9-20211019.121837.gitf067b3ce
- Type: bugfix
- ID: NA
- SUG: NA
- DESC: strip sha256 prefix when decrease hold references

* Fri Jun 25 2021 wujing <wujing50@huawei.com> - 2.0.9-20210625.165022.git5a088d9c
- Type: update to v2.0.9
- ID: NA
- SUG: NA
- DESC: update from master

* Tue May 18 2021 wangfengtu <wangfengtu@huawei.com> - 2.0.8-20210518.144540.git5288ed92
- Type: sync from upstream
- ID: NA
- SUG: NA
- DESC: update from master

* Fri Mar 26 2021 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.8-20210326.094027.gitac974aa6
- Type: sync from upstream
- ID: NA
- SUG: NA
- DESC: update from master

* Tue Mar 23 2021 haozi007 <liuhao27@huawei.com> - 20210323.094917.git7e6aa593
- Type: sync from upstream
- ID: NA
- SUG: NA
- DESC: update from master

* Tue Feb 2 2021 lifeng <lifeng68@huawei.com> - 2.0.8-20210202.153251.gite082dcf3
- Type: sync from upstream
- ID: NA
- SUG: NA
- DESC: update from master

* Mon Jan 18 2021 lifeng <lifeng68@huawei.com> - 2.0.8-20210118.195254.git077e10f2
- Type: sync from upstream
- ID: NA
- SUG: NA
- DESC: update from master

* Wed Dec 30 2020 lifeng <lifeng68@huawei.com> - 2.0.8-20201230.155843.git6557a6eb
- Type: update to v2.0.8
- ID: NA
- SUG: NA
- DESC: update from master

* Mon Dec 7 2020 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.7-20201207.151847.gita1fce123
- Type: update
- ID: NA
- SUG: NA
- DESC: update from master

* Sat Dec 5 2020 lifeng <lifeng68@huawei.com> - 2.0.7-20201205.145752.gita461cc51
- Type: bugfix
- ID:NA
- SUG:NA
- DESC: ignore list containers errors

* Thu Dec 3 2020 haozi007 <liuhao27@huawei.com> - 2.0.7-20201203.190902.git48f598fd
- Type:update from master
- ID:NA
- SUG:NA
- DESC: update from master

* Sat Nov 28 2020 lifeng<lifeng68@huawei.com> - 2.0.7-20201128.095506.git1e1623a5
- Type: bugfix
- ID:NA
- SUG:NA
- DESC: Mounts: only qsort the configed mounts and make possible to bind mount /proc and /sys/fs.
- related lxc PR fixed:
- 1.add check whether have /proc mounts entry, if has, skip the auto
- 2.mount cgroup before do mount entrys
- 3.pass if the mount on top of /proc and the source of the mount is a proc filesystem

* Wed Nov 25 2020  wangfengtu<wangfengtu@huawei.com> - 2.0.7-20201125.165149.git7d150c3c
- Type: bugfix
- ID:NA
- SUG:NA
- DESC: update from openeuler

* Wed Nov 25 2020  wangfengtu<wangfengtu@huawei.com> - 2.0.6-20201125.160534.git9fb5e75d
- Type: bugfix
- ID:NA
- SUG:NA
- DESC: fix rpath not work

* Thu Nov 12 2020  gaohuatao<gaohuatao@huawei.com> - 2.0.6-20201112.193005.git8a6b73c8
- Type: update from openeuler
- ID:NA
- SUG:NA
- DESC: update from openeuler

* Wed Oct 14 2020  lifeng68<lifeng68@huawei.com> - 2.0.6-20201014.152749.gitc8a43925
- Type: upgrade to v2.0.6
- ID:NA
- SUG:NA
- DESC: upgrade to v2.0.6

* Fri Sep 18 2020  <lifeng68@huawei.com> - 2.0.5-20200918.112827.git9aea9b75
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: modify log level to warn

* Mon Sep 14 2020  <lifeng68@huawei.com> - 2.0.5-20200914.172527.gitae86920a
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: remove unused config

* Thu Sep 10 2020  <yangjiaqi11@huawei.com> - 2.0.5-20200910.144345.git71b1055b
- Type:enhancement
- ID:NA
- SUG:NA
- DESC: add chrpath

* Fri Sep 04 2020 zhangxiaoyu <zhangxiaoyu58@huawei.com> - 2.0.5-20200904.114315.gitff1761c3
- Type:enhancement
- ID:NA
- SUG:NA
- DESC: upgrade from v2.0.3 to v2.0.5

* Wed Sep 02 2020 YoungJQ <yangjiaqi11@huawei.com> - 2.0.3-20200902.114727.git6d945f26
- Type:enhancement
- ID:NA
- SUG:NA
- DESC: modify source0 address
